// ============================================================================
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2013 - Scilab Enterprises - Charlotte HECQUET
//
//  This file is distributed under the same license as the Scilab package.
// ============================================================================
//
// <-- ENGLISH IMPOSED -->
//
// <-- Short Description -->
// Test MEAI_IdealGyrator

[a, coselicaMacrosPath] = libraryinfo(whereis(getCoselicaVersion));

try
    ilib_verbose(0);
    assert_checktrue(importXcosDiagram(fullfile(coselicaMacrosPath, "../../tests/unit_tests/Electrical/Ideal/MEAI_IdealGyrator.zcos")));
    xcos_simulate(scs_m, 4);

    Ie = res.values(:,1);
    Is = res.values(:,2);
    Ve = res.values(:,4);
    Vs = res.values(:,3);
    G = 2;

    assert_checkequal(Ie, G*Vs);
    assert_checkequal(Is, G*Ve);

catch
   disp(lasterror())
   assert_checktrue(%f);
end
